// ProiectDlg.cpp : implementation file
//	EVM 3530 I2C comunication
//	sensor tipe TMP100
//		
//

#include "stdafx.h"
#include "Proiect.h"
#include "ProiectDlg.h"

#ifdef _DEBUG
#define new DEBUG_NEW
#endif

// Slave I2C adress
#define IOCTL_I2C_SET_SLAVE_ADDRESS   0x220800

HANDLE hPort = NULL ;
BOOL result;
DWORD dwSlaveAddr;

// temperature variabile
float t1,t2;

// timer
// for 1 sec temp mensurement
#define  IDT_TIMER  WM_USER + 400

// variabila de timp time
	CTime current_time;
	CString time_str;

// CProiectDlg dialog

CProiectDlg::CProiectDlg(CWnd* pParent /*=NULL*/)
	: CDialog(CProiectDlg::IDD, pParent)
{
	m_hIcon = AfxGetApp()->LoadIcon(IDR_MAINFRAME);
}

void CProiectDlg::DoDataExchange(CDataExchange* pDX)
{
	CDialog::DoDataExchange(pDX);
	DDX_Control(pDX, IDC_EDIT1, temp1);
	DDX_Control(pDX, IDC_EDIT2, temp2);
	DDX_Control(pDX, IDC_EDIT3, status);
}

BEGIN_MESSAGE_MAP(CProiectDlg, CDialog)
#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
	ON_WM_SIZE()
#endif
	//}}AFX_MSG_MAP
	ON_BN_CLICKED(IDC_READ, &CProiectDlg::OnBnClickedRead)
	ON_WM_TIMER()
	ON_BN_CLICKED(IDC_END, &CProiectDlg::OnBnClickedEnd)
END_MESSAGE_MAP()


// CProiectDlg message handlers

BOOL CProiectDlg::OnInitDialog()
{
	CDialog::OnInitDialog();

	// Set the icon for this dialog.  The framework does this automatically
	//  when the application's main window is not a dialog
	SetIcon(m_hIcon, TRUE);			// Set big icon
	SetIcon(m_hIcon, FALSE);		// Set small icon

	return TRUE;  // return TRUE  unless you set the focus to a control
}

#if defined(_DEVICE_RESOLUTION_AWARE) && !defined(WIN32_PLATFORM_WFSP)
void CProiectDlg::OnSize(UINT /*nType*/, int /*cx*/, int /*cy*/)
{
	if (AfxIsDRAEnabled())
	{
		DRA::RelayoutDialog(
			AfxGetResourceHandle(), 
			this->m_hWnd, 
			DRA::GetDisplayMode() != DRA::Portrait ? 
			MAKEINTRESOURCE(IDD_PROIECT_DIALOG_WIDE) : 
			MAKEINTRESOURCE(IDD_PROIECT_DIALOG));
	}
}
#endif

void CProiectDlg::OnBnClickedRead()
{
	// timer start
	UINT_PTR TimerVal;
	TimerVal = SetTimer (IDT_TIMER, 100, NULL);
}

void CProiectDlg::OnTimer(UINT_PTR nIDEvent)
{
	// temperature that will be read
	unsigned char indata[2] ={0,0};
	DWORD len = 2;

	// TODO: Add your message handler code here and/or call default
	CDialog::OnTimer(nIDEvent);

	// temperature redings 1
	dwSlaveAddr = 0x49;
	hPort = CreateFile(TEXT("I2C2:"),GENERIC_READ | GENERIC_WRITE,0,0,OPEN_EXISTING,0,NULL);
	if( hPort == INVALID_HANDLE_VALUE) 
		{
			AfxMessageBox(L"unable open i2c2 port", NULL, NULL);
			CloseHandle(hPort);
		}
  
	result = DeviceIoControl(hPort, IOCTL_I2C_SET_SLAVE_ADDRESS, &dwSlaveAddr,                             
							sizeof(dwSlaveAddr), NULL, 0, NULL, NULL);
	if (!result)
		{
			AfxMessageBox(L"DeviceIoControl failed", NULL, NULL);
			CloseHandle(hPort);
		}
	SetFilePointer(hPort, 0, NULL, FILE_BEGIN);
	len=2;	
    result = ReadFile(hPort, indata, 2, &len, 0);
    if (result)
		{
			status.SetWindowTextW(_T("The data was read ..."));
			t1=(float)((indata[0])+ 
						((indata[1] & 0x80)? 0.5 : 0) + 
						((indata[1] & 0x40)? 0.25 : 0) + 
						((indata[1] & 0x20)? 0.125 : 0) + 
						((indata[1] & 0x10)? 0.0625 : 0) );
		}
	CloseHandle(hPort);
	
	// temperature redings 2
	dwSlaveAddr = 0x48;
	hPort = CreateFile(TEXT("I2C2:"),GENERIC_READ | GENERIC_WRITE,0,0,OPEN_EXISTING,0,NULL);
	if( hPort == INVALID_HANDLE_VALUE) 
		{
			AfxMessageBox(L"unable open i2c2 port", NULL, NULL);
			CloseHandle(hPort);
		}
  
	result = DeviceIoControl(hPort, IOCTL_I2C_SET_SLAVE_ADDRESS, &dwSlaveAddr,                             
	sizeof(dwSlaveAddr), NULL, 0, NULL, NULL);
	if (!result)
		{
			AfxMessageBox(L"DeviceIoControl failed", NULL, NULL);
			CloseHandle(hPort);
		}
	SetFilePointer(hPort, 0, NULL, FILE_BEGIN);
	len=2;	
    result = ReadFile(hPort, indata, 2, &len, 0);
    if (result)
		{
			status.SetWindowTextW(_T("The data was read ..."));
			t2=(float)((indata[0]) + 
						((indata[1] & 0x80)? 0.5 : 0) + 
						((indata[1] & 0x40)? 0.25 : 0) + 
						((indata[1] & 0x20)? 0.125 : 0) + 
						((indata[1] & 0x10)? 0.0625 : 0) );
		}
	CloseHandle(hPort);

	CString txt;
	//	afisarea
	txt.Format(_T("%0.1f C"),t1);
	temp1.SetWindowTextW(txt);

	txt.Format(_T("%0.1f C"),t2);
	temp2.SetWindowTextW(txt);
}

void CProiectDlg::OnBnClickedEnd()
{
	// timer stop
	UINT_PTR TimerVal;
	TimerVal = KillTimer (IDT_TIMER);
	temp1.SetWindowTextW(_T(""));
	temp2.SetWindowTextW(_T(""));
	status.SetWindowTextW(_T("Test End"));
}